diff --git a/contrib/ntp/ntpd/ntp_scanner.c b/contrib/ntp/ntpd/ntp_scanner.c
index 08c203c63e8a..531d66024982 100644
--- a/contrib/ntp/ntpd/ntp_scanner.c
+++ b/contrib/ntp/ntpd/ntp_scanner.c
@@ -34,7 +34,7 @@
  * ------------------------
  */
 
-#define MAX_LEXEME (1024 + 1)	/* The maximum size of a lexeme */
+#define MAX_LEXEME	128	/* The maximum size of a lexeme */
 char yytext[MAX_LEXEME];	/* Buffer for storing the input text/lexeme */
 u_int32 conf_file_sum;		/* Simple sum of characters read */
 
@@ -278,7 +278,7 @@ lex_close(
  */
 
 static struct FILE_INFO *
-_drop_stack_do(
+drop_stack_do(
 	struct FILE_INFO * head
 	)
 {
@@ -320,9 +320,9 @@ lex_init_stack(
  * anything until the next 'lex_init_stack()' succeeded.
  */
 void
-lex_drop_stack()
+lex_drop_stack(void)
 {
-	lex_stack = _drop_stack_do(lex_stack);
+	lex_stack = drop_stack_do(lex_stack);
 }
 
 /* Flush the lexer input stack: This will nip all input objects on the
@@ -334,14 +334,14 @@ lex_drop_stack()
  * in the force-eof mode before this call.
  */
 int/*BOOL*/
-lex_flush_stack()
+lex_flush_stack(void)
 {
 	int retv = FALSE;
 
 	if (NULL != lex_stack) {
 		retv = !lex_stack->force_eof;
 		lex_stack->force_eof = TRUE;
-		lex_stack->st_next = _drop_stack_do(
+		lex_stack->st_next = drop_stack_do(
 					lex_stack->st_next);
 	}
 	return retv;
@@ -425,7 +425,7 @@ lex_from_file(void)
 }
 
 struct FILE_INFO *
-lex_current()
+lex_current(void)
 {
 	/* this became so simple, it could be a macro. But then,
 	 * lex_stack needed to be global...
@@ -910,9 +910,9 @@ yylex(void)
 
 normal_return:
 	if (T_EOC == token)
-		DPRINTF(4,("\t<end of command>\n"));
+		DPRINTF(10, ("\t<end of command>\n"));
 	else
-		DPRINTF(4, ("yylex: lexeme '%s' -> %s\n", yytext,
+		DPRINTF(10, ("yylex: lexeme '%s' -> %s\n", yytext,
 			    token_name(token)));
 
 	if (!yylval_was_set)
@@ -921,6 +921,10 @@ yylex(void)
 	return token;
 
 lex_too_long:
+	/*
+	 * DLH: What is the purpose of the limit of 50?
+	 * Is there any reason for yytext[] to be bigger?
+	 */
 	yytext[min(sizeof(yytext) - 1, 50)] = 0;
 	msyslog(LOG_ERR, 
 		"configuration item on line %d longer than limit of %lu, began with '%s'",
diff --git a/contrib/ntp/ntpd/ntp_timer.c b/contrib/ntp/ntpd/ntp_timer.c
index 4f669f0699fa..c8164d798b04 100644
--- a/contrib/ntp/ntpd/ntp_timer.c
+++ b/contrib/ntp/ntpd/ntp_timer.c
@@ -46,7 +46,7 @@ static void check_leapsec(u_int32, const time_t*, int/*BOOL*/);
 
 /*
  * These routines provide support for the event timer.  The timer is
- * implemented by an interrupt routine which sets a flag once every
+ * implemented by a signal routine which sets a flag once every
  * second, and a timer routine which is called when the mainline code
  * gets around to seeing the flag.  The timer routine dispatches the
  * clock adjustment code if its time has come, then searches the timer
@@ -54,7 +54,6 @@ static void check_leapsec(u_int32, const time_t*, int/*BOOL*/);
  * Finally, we call the hourly procedure to do cleanup and print a
  * message.
  */
-volatile int interface_interval;     /* init_io() sets def. 300s */
 
 /*
  * Initializing flag.  All async routines watch this and only do their
@@ -70,14 +69,15 @@ volatile int alarm_flag;
 /*
  * The counters and timeouts
  */
-static  u_long interface_timer;	/* interface update timer */
+	u_long endpt_scan_timer;	/* interface update timer */
 static	u_long adjust_timer;	/* second timer */
 static	u_long stats_timer;	/* stats timer */
 static	u_long leapf_timer;	/* Report leapfile problems once/day */
 static	u_long huffpuff_timer;	/* huff-n'-puff timer */
 static	u_long worker_idle_timer;/* next check for idle intres */
-u_long	leapsec;	        /* seconds to next leap (proximity class) */
-int     leapdif;                /* TAI difference step at next leap second*/
+int	endpt_scan_period;	/* init_io() sets def. 301s */
+u_long	leapsec;		/* seconds to next leap (proximity class) */
+int	leapdif;		/* TAI difference step at next leap second*/
 u_long	orphwait; 		/* orphan wait time */
 #ifdef AUTOKEY
 static	u_long revoke_timer;	/* keys revoke timer */
@@ -198,7 +198,7 @@ init_timer(void)
 	stats_timer = SECSPERHR;
 	leapf_timer = SECSPERDAY;
 	huffpuff_timer = 0;
-	interface_timer = 0;
+	endpt_scan_timer = 0;
 	current_time = 0;
 	timer_overflows = 0;
 	timer_xmtcalls = 0;
@@ -249,7 +249,7 @@ init_timer(void)
 		BOOL		rc;
 
 		Period = (1 << EVENT_TIMEOUT) * 1000;
-		DueTime.QuadPart = Period * 10000i64;
+		DueTime.QuadPart = Period * 10000ll;
 		rc = SetWaitableTimer(WaitableTimerHandle, &DueTime,
 				      Period, NULL, NULL, FALSE);
 		if (!rc) {
@@ -296,10 +296,10 @@ intres_timeout_req(
 void
 timer(void)
 {
-	struct peer *	p;
-	struct peer *	next_peer;
+	struct peer* p;
+	struct peer* next_peer;
 	l_fp		now;
-	time_t          tnow;
+	time_t		tnow;
 
 	/*
 	 * The basic timerevent is one second.  This is used to adjust the
@@ -333,15 +333,18 @@ timer(void)
 		 * usually tripped using iburst and minpoll of
 		 * 128 s or less.
 		 */
-		if (p->throttle > 0)
+		if (p->throttle > 0) {
 			p->throttle--;
+		}
 		if (p->nextdate <= current_time) {
 #ifdef REFCLOCK
-			if (FLAG_REFCLOCK & p->flags)
+			if (FLAG_REFCLOCK & p->flags) {
 				refclock_transmit(p);
-			else
+			} else
 #endif	/* REFCLOCK */
+			{
 				transmit(p);
+			}
 		}
 	}
 
@@ -370,7 +373,8 @@ timer(void)
 #endif	/* AUTOKEY */
 			}
 			sys_stratum = (u_char)sys_orphan;
-		} else {
+		}
+		else {
 			if (sys_leap != LEAP_NOTINSYNC) {
 				set_sys_leap(LEAP_NOTINSYNC);
 				msyslog(LOG_WARNING, "%s",
@@ -379,9 +383,9 @@ timer(void)
 			sys_stratum = STRATUM_UNSPEC;
 		}
 		if (sys_stratum > 1)
-		    sys_refid = htonl(LOOPBACKADR);
+			sys_refid = htonl(LOOPBACKADR);
 		else
-		    memcpy(&sys_refid, "LOOP", 4);
+			memcpy(&sys_refid, "ORPH", 4);
 		sys_offset = 0;
 		sys_rootdelay = 0;
 		sys_rootdisp = 0;
@@ -395,17 +399,19 @@ timer(void)
 	 * is imminent or every 8th second.
 	 */
 	if (leapsec > LSPROX_NOWARN || 0 == (current_time & 7))
-		check_leapsec(now.l_ui, &tnow,
-                                (sys_leap == LEAP_NOTINSYNC));
-        if (sys_leap != LEAP_NOTINSYNC) {
-                if (leapsec >= LSPROX_ANNOUNCE && leapdif) {
-		        if (leapdif > 0)
-			        set_sys_leap(LEAP_ADDSECOND);
-		        else
-			        set_sys_leap(LEAP_DELSECOND);
-                } else {
-                        set_sys_leap(LEAP_NOWARNING);
-                }
+		check_leapsec( now.l_ui
+			     , &tnow
+			     , (sys_leap == LEAP_NOTINSYNC));
+	if (sys_leap != LEAP_NOTINSYNC) {
+		if (leapsec >= LSPROX_ANNOUNCE && leapdif) {
+			if (leapdif > 0) {
+				set_sys_leap(LEAP_ADDSECOND);
+			} else {
+				set_sys_leap(LEAP_DELSECOND);
+			}
+		} else {
+			set_sys_leap(LEAP_NOWARNING);
+		}
 	}
 
 	/*
@@ -431,23 +437,28 @@ timer(void)
 	 */
 	if (revoke_timer && revoke_timer <= current_time) {
 		revoke_timer += (1UL << sys_revoke);
-		RAND_bytes((u_char *)&sys_private, 4);
+		RAND_bytes((u_char *)&sys_private, sizeof(sys_private));
 	}
 #endif	/* AUTOKEY */
 
 	/*
-	 * Interface update timer
+	 * Network interface rescan timer
 	 */
-	if (interface_interval && interface_timer <= current_time) {
-		timer_interfacetimeout(current_time +
-		    interface_interval);
-		DPRINTF(2, ("timer: interface update\n"));
+	if (endpt_scan_timer && endpt_scan_timer <= current_time) {
+		if (no_periodic_scan) {
+			endpt_scan_timer = 0;
+			DPRINTF(2, ("timer: network interface rescan disabled\n"));
+		} else {
+			endpt_scan_timer =   current_time
+					   + endpt_scan_period;
+			DPRINTF(2, ("timer: network interface rescan in %d seconds\n", endpt_scan_period));
+		}
 		interface_update(NULL, NULL);
 	}
 
-	if (worker_idle_timer && worker_idle_timer <= current_time)
+	if (worker_idle_timer && worker_idle_timer <= current_time) {
 		worker_idle_timer_fired();
-
+	}
 	/*
 	 * Finally, write hourly stats and do the hourly
 	 * and daily leapfile checks.
@@ -508,13 +519,6 @@ alarming(
 #endif /* SYS_WINNT */
 
 
-void
-timer_interfacetimeout(u_long timeout)
-{
-	interface_timer = timeout;
-}
-
-
 /*
  * timer_clr_stats - clear timer module stat counters
  */
@@ -528,21 +532,27 @@ timer_clr_stats(void)
 
 
 static void
-check_leap_sec_in_progress( const leap_result_t *lsdata ) {
+check_leap_sec_in_progress(
+	const leap_result_t *lsdata
+	)
+{
 	int prv_leap_sec_in_progress = leap_sec_in_progress;
+
 	leap_sec_in_progress = lsdata->tai_diff && (lsdata->ddist < 3);
 
-	/* if changed we may have to update the leap status sent to clients */
-	if (leap_sec_in_progress != prv_leap_sec_in_progress)
+	/* if changed we have to update the leap bits sent to clients */
+	if (leap_sec_in_progress != prv_leap_sec_in_progress) {
 		set_sys_leap(sys_leap);
+	}
 }
 
 
 static void
 check_leapsec(
-	u_int32        now  ,
-	const time_t * tpiv ,
-        int/*BOOL*/    reset)
+	u_int32		now,
+	const time_t *	tpiv,
+	int/*BOOL*/	reset
+	)
 {
 	static const char leapmsg_p_step[] =
 	    "Positive leap second, stepped backward.";
@@ -556,10 +566,10 @@ check_leapsec(
 	    "Negative leap second, no step correction. "
 	    "System clock will be inaccurate for a long time.";
 
-	leap_result_t lsdata;
-	u_int32       lsprox;
+	leap_result_t	lsdata;
+	u_int32		lsprox;
 #ifdef AUTOKEY
-	int/*BOOL*/   update_autokey = FALSE;
+	int/*BOOL*/	update_autokey = FALSE;
 #endif
 
 #ifndef SYS_WINNT  /* WinNT port has its own leap second handling */
@@ -568,122 +578,116 @@ check_leapsec(
 # else
 	leapsec_electric(0);
 # endif
-#endif
+#endif	/* !SYS_WINNT */
+
 #ifdef LEAP_SMEAR
 	leap_smear.enabled = leap_smear_intv != 0;
 #endif
 	if (reset) {
 		lsprox = LSPROX_NOWARN;
 		leapsec_reset_frame();
-		memset(&lsdata, 0, sizeof(lsdata));
+		ZERO(lsdata);
 	} else {
-	  int fired;
+		int fired;
 
-	  fired = leapsec_query(&lsdata, now, tpiv);
+		fired = leapsec_query(&lsdata, now, tpiv);
 
-	  DPRINTF(3, ("*** leapsec_query: fired %i, now %u (0x%08X), tai_diff %i, ddist %u\n",
-		  fired, now, now, lsdata.tai_diff, lsdata.ddist));
+		DPRINTF(3, ("*** leapsec_query: fired %i, now %u (0x%08X),"
+			    " tai_diff %i, ddist %u\n",
+			    fired, now, now, lsdata.tai_diff, lsdata.ddist));
 
 #ifdef LEAP_SMEAR
-	  leap_smear.in_progress = 0;
-	  leap_smear.doffset = 0.0;
-
-	  if (leap_smear.enabled) {
-		if (lsdata.tai_diff) {
-			if (leap_smear.interval == 0) {
-				leap_smear.interval = leap_smear_intv;
-				leap_smear.intv_end = lsdata.ttime.Q_s;
-				leap_smear.intv_start = leap_smear.intv_end - leap_smear.interval;
-				DPRINTF(1, ("*** leapsec_query: setting leap_smear interval %li, begin %.0f, end %.0f\n",
+		leap_smear.in_progress = FALSE;
+		leap_smear.doffset = 0.0;
+
+		if (leap_smear.enabled) {
+			if (lsdata.tai_diff) {
+				if (0 == leap_smear.interval) {
+					leap_smear.interval = leap_smear_intv;
+					leap_smear.intv_end = lsdata.ttime.Q_s;
+					leap_smear.intv_start = leap_smear.intv_end - leap_smear.interval;
+					DPRINTF(1, ("*** leapsec_query: setting leap_smear interval %li, begin %.0f, end %.0f\n",
 					leap_smear.interval, leap_smear.intv_start, leap_smear.intv_end));
+				}
+			} else {
+				if (leap_smear.interval) {
+					DPRINTF(1, ("*** leapsec_query: clearing leap_smear interval\n"));
+					leap_smear.interval = 0;
+				}
 			}
-		} else {
-			if (leap_smear.interval)
-				DPRINTF(1, ("*** leapsec_query: clearing leap_smear interval\n"));
-			leap_smear.interval = 0;
-		}
 
-		if (leap_smear.interval) {
-			double dtemp = now;
-			if (dtemp >= leap_smear.intv_start && dtemp <= leap_smear.intv_end) {
-				double leap_smear_time = dtemp - leap_smear.intv_start;
-				/*
-				 * For now we just do a linear interpolation over the smear interval
-				 */
+			if (leap_smear.interval) {
+				double dtemp = now;
+
+				if (dtemp >= leap_smear.intv_start && dtemp <= leap_smear.intv_end) {
+					double leap_smear_time = dtemp - leap_smear.intv_start;
 #if 0
-				// linear interpolation
-				leap_smear.doffset = -(leap_smear_time * lsdata.tai_diff / leap_smear.interval);
+					/*  linear interpolation */
+					leap_smear.doffset = -(leap_smear_time * lsdata.tai_diff / leap_smear.interval);
 #else
-				// Google approach: lie(t) = (1.0 - cos(pi * t / w)) / 2.0
-				leap_smear.doffset = -((double) lsdata.tai_diff - cos( M_PI * leap_smear_time / leap_smear.interval)) / 2.0;
+					/* Google approach : lie(t) = (1.0 - cos(pi * t / w)) / 2.0 */
+					leap_smear.doffset = -((double) lsdata.tai_diff - cos( M_PI * leap_smear_time / leap_smear.interval)) / 2.0;
 #endif
-				/*
-				 * TODO see if we're inside an inserted leap second, so we need to compute
-				 * leap_smear.doffset = 1.0 - leap_smear.doffset
-				 */
-				leap_smear.in_progress = 1;
-#if 0 && defined( DEBUG )
-				msyslog(LOG_NOTICE, "*** leapsec_query: [%.0f:%.0f] (%li), now %u (%.0f), smear offset %.6f ms\n",
-					leap_smear.intv_start, leap_smear.intv_end, leap_smear.interval,
-					now, leap_smear_time, leap_smear.doffset);
-#else
-				DPRINTF(1, ("*** leapsec_query: [%.0f:%.0f] (%li), now %u (%.0f), smear offset %.6f ms\n",
+					/*
+					 * TODO see if we're inside an inserted leap second, so we need to compute
+					 * leap_smear.doffset = 1.0 - leap_smear.doffset
+					 */
+					leap_smear.in_progress = TRUE;
+					DPRINTF(1, ("*** leapsec_query: [%.0f:%.0f] (%li), now %u (%.0f), smear offset %.6f ms\n",
 					leap_smear.intv_start, leap_smear.intv_end, leap_smear.interval,
 					now, leap_smear_time, leap_smear.doffset));
-#endif
 
+				}
 			}
+		} else {
+			leap_smear.interval = 0;
 		}
-	  }
-	  else
-		leap_smear.interval = 0;
-
-	  /*
-	   * Update the current leap smear offset, eventually 0.0 if outside smear interval.
-	   */
-	  DTOLFP(leap_smear.doffset, &leap_smear.offset);
-
+		/*
+		 * Update the current leap smear offset, eventually 0.0 if outside smear interval.
+		 */
+		DTOLFP(leap_smear.doffset, &leap_smear.offset);
 #endif	/* LEAP_SMEAR */
 
-	  if (fired) {
-		/* Full hit. Eventually step the clock, but always
-		 * announce the leap event has happened.
-		 */
-		const char *leapmsg = NULL;
-		double      lswarp  = lsdata.warped;
-		if (lswarp < 0.0) {
-			if (clock_max_back > 0.0 &&
-			    clock_max_back < -lswarp) {
-				step_systime(lswarp);
-				leapmsg = leapmsg_p_step;
-			} else {
-				leapmsg = leapmsg_p_slew;
+		if (fired) {
+			/* Full hit. Eventually step the clock, but always
+			 * announce the leap event has happened.
+			 */
+			const char *leapmsg = NULL;
+			double      lswarp  = lsdata.warped;
+			if (lswarp < 0.0) {
+				if (clock_max_back > 0.0 &&
+				    clock_max_back < -lswarp) {
+					step_systime(lswarp);
+					leapmsg = leapmsg_p_step;
+				} else {
+					leapmsg = leapmsg_p_slew;
+				}
+			} else 	if (lswarp > 0.0) {
+				if (clock_max_fwd > 0.0 &&
+				    clock_max_fwd < lswarp) {
+					step_systime(lswarp);
+					leapmsg = leapmsg_n_step;
+				} else {
+					leapmsg = leapmsg_n_slew;
+				}
 			}
-		} else 	if (lswarp > 0.0) {
-			if (clock_max_fwd > 0.0 &&
-			    clock_max_fwd < lswarp) {
-				step_systime(lswarp);
-				leapmsg = leapmsg_n_step;
-			} else {
-				leapmsg = leapmsg_n_slew;
+			if (leapmsg) {
+				msyslog(LOG_NOTICE, "%s", leapmsg);
 			}
-		}
-		if (leapmsg)
-			msyslog(LOG_NOTICE, "%s", leapmsg);
-		report_event(EVNT_LEAP, NULL, NULL);
+			report_event(EVNT_LEAP, NULL, NULL);
 #ifdef AUTOKEY
-		update_autokey = TRUE;
+			update_autokey = TRUE;
 #endif
-		lsprox  = LSPROX_NOWARN;
-		leapsec = LSPROX_NOWARN;
-		sys_tai = lsdata.tai_offs;
-	  } else {
+			lsprox  = LSPROX_NOWARN;
+			leapsec = LSPROX_NOWARN;
+			sys_tai = lsdata.tai_offs;
+		} else {
 #ifdef AUTOKEY
-		  update_autokey = (sys_tai != (u_int)lsdata.tai_offs);
+			update_autokey = (sys_tai != (u_int)lsdata.tai_offs);
 #endif
-		  lsprox  = lsdata.proximity;
-		  sys_tai = lsdata.tai_offs;
-	  }
+			lsprox  = lsdata.proximity;
+			sys_tai = lsdata.tai_offs;
+		}
 	}
 
 	/* We guard against panic alarming during the red alert phase.
@@ -691,13 +695,13 @@ check_leapsec(
 	 * to piping hot in one step. If things are already that wobbly,
 	 * we let the normal clock correction take over, even if a jump
 	 * is involved.
-         * Also make sure the alarming events are edge-triggered, that is,
-         * ceated only when the threshold is crossed.
-         */
-	if (  (leapsec > 0 || lsprox < LSPROX_ALERT)
-	    && leapsec < lsprox                     ) {
+	 * Also make sure the alarming events are edge-triggered, that is,
+	 * created only when the threshold is crossed.
+	 */
+	if (   (leapsec > 0 || lsprox < LSPROX_ALERT)
+	    && leapsec < lsprox) {
 		if (  leapsec < LSPROX_SCHEDULE
-                   && lsprox >= LSPROX_SCHEDULE) {
+		   && lsprox >= LSPROX_SCHEDULE) {
 			if (lsdata.dynamic)
 				report_event(PEVNT_ARMED, sys_peer, NULL);
 			else
@@ -706,22 +710,23 @@ check_leapsec(
 		leapsec = lsprox;
 	}
 	if (leapsec > lsprox) {
-		if (  leapsec >= LSPROX_SCHEDULE
-                   && lsprox   < LSPROX_SCHEDULE) {
+		if (   leapsec >= LSPROX_SCHEDULE
+		    && lsprox   < LSPROX_SCHEDULE) {
 			report_event(EVNT_DISARMED, NULL, NULL);
 		}
 		leapsec = lsprox;
 	}
 
-	if (leapsec >= LSPROX_SCHEDULE)
+	if (leapsec >= LSPROX_SCHEDULE) {
 		leapdif = lsdata.tai_diff;
-	else
+	} else {
 		leapdif = 0;
-
+	}
 	check_leap_sec_in_progress(&lsdata);
 
 #ifdef AUTOKEY
-	if (update_autokey)
+	if (update_autokey) {
 		crypto_update_taichange();
+	}
 #endif
 }
diff --git a/contrib/ntp/ntpd/ntp_util.c b/contrib/ntp/ntpd/ntp_util.c
index 62a997e43aad..e7b374fc346f 100644
--- a/contrib/ntp/ntpd/ntp_util.c
+++ b/contrib/ntp/ntpd/ntp_util.c
@@ -13,7 +13,6 @@
 #include "ntp_assert.h"
 #include "ntp_calendar.h"
 #include "ntp_leapsec.h"
-#include "lib_strbuf.h"
 
 #include <stdio.h>
 #include <ctype.h>
@@ -63,7 +62,6 @@ char	*stats_drift_file;		/* frequency file name */
 static	char *stats_temp_file;		/* temp frequency file name */
 static double wander_resid;		/* last frequency update */
 double	wander_threshold = 1e-7;	/* initial frequency threshold */
-static unsigned int cmdargs_seen = 0;	/* stat options seen from command line */
 
 /*
  * Statistics file stuff
@@ -183,7 +181,7 @@ init_util(void)
 void
 write_stats(void)
 {
-	FILE	*fp;
+	FILE	*fp = NULL;
 #ifdef DOSYNCTODR
 	struct timeval tv;
 #if !defined(VMS)
@@ -267,12 +265,10 @@ write_stats(void)
 		 * the frequncy file. This minimizes the file writes to
 		 * nonvolaile storage.
 		 */
-#ifdef DEBUG
-		if (debug)
-			printf("write_stats: frequency %.6lf thresh %.6lf, freq %.6lf\n",
+		DPRINTF(1, ("write_stats: frequency %.6f thresh %.6f, freq %.6f\n",
 			    (prev_drift_comp - drift_comp) * 1e6, wander_resid *
-			    1e6, drift_comp * 1e6);
-#endif
+			    1e6, drift_comp * 1e6));
+
 		if (fabs(prev_drift_comp - drift_comp) < wander_resid) {
 			wander_resid *= 0.5;
 			return;
@@ -284,7 +280,7 @@ write_stats(void)
 			    stats_temp_file);
 			return;
 		}
-		fprintf(fp, "%.3f\n", drift_comp * 1e6);
+		fprintf(fp, "%.6f\n", drift_comp * 1e6);
 		(void)fclose(fp);
 		/* atomic */
 #ifdef SYS_WINNT
@@ -326,29 +322,38 @@ write_stats(void)
 
 
 /*
- * stats_config - configure the stats operation
+ * If an option was given on the command line make sure it takes
+ * precedence over the configuration file, as command-line options
+ * are processed first.  Similarly, if an option is given in the
+ * configuration file, do not allow it to be overridden with runtime
+ * configuration.  Done by simply remembering an option was already
+ * seen.
  */
 static int
 allow_config(
-	unsigned int	option,
-	int/*BOOL*/	cmdopt)
+	u_int		option,
+	int/*BOOL*/	cmdopt
+	)
 {
-	/* If an option was given on the command line, make sure it
-	 * persists and is not later changed by a corresponding option
-	 * from the config file. Done by simply remembering an option was
-	 * already seen from the command line.
-	 * 
-	 * BTW, if we ever define stats options beyond 31, this needs a
-	 * fix. Until then, simply assume the shift will not overflow.
-	 */
-	unsigned int mask = 1u << option;
-	int          retv = cmdopt || !(cmdargs_seen & mask);
-	if (cmdopt) 
-		cmdargs_seen |= mask;
+	static u_int	seen = 0;	/* stat options previously set */
+	u_int		mask;
+	int		retv;
+
+	if (cmdopt) {
+		DEBUG_REQUIRE(option < sizeof(mask) * 8);
+		mask = 1u << option;
+		retv = !(seen & mask);
+		seen |= mask;
+	} else {
+		retv = FALSE;
+	}
 	return retv;
 }
 
 
+/*
+ * stats_config - configure the stats operation
+ */
 void
 stats_config(
 	int item,
@@ -356,12 +361,13 @@ stats_config(
 	int optflag
 	)
 {
-	FILE	*fp;
+	FILE	*fp = NULL;
 	const char *value;
 	size_t	len;
 	double	old_drift;
 	l_fp	now;
 	time_t  ttnow;
+	char	dirsep_or_nul;
 #ifndef VMS
 	static const char temp_ext[] = ".TEMP";
 #else
@@ -415,137 +421,131 @@ stats_config(
 
 	switch (item) {
 
-	/*
-	 * Open and read frequency file.
-	 */
+		/*
+		 * Open and read frequency file.
+		 */
 	case STATS_FREQ_FILE:
-		if (!allow_config(STATS_FREQ_FILE, optflag))
+		if (!allow_config(STATS_FREQ_FILE, optflag)) {
 			break;
-		
-		if (!value || (len = strlen(value)) == 0)
-		{
+		}
+		if (!value || 0 == (len = strlen(value))) {
 			free(stats_drift_file);
 			free(stats_temp_file);
-			stats_drift_file = stats_temp_file = NULL;    
-		}
-		else
-		{
-			stats_drift_file = erealloc(stats_drift_file, len + 1);
+			stats_drift_file = stats_temp_file = NULL;
+		} else {
+			stats_drift_file = erealloc(stats_drift_file,
+						    1 + len);
 			stats_temp_file = erealloc(stats_temp_file,
-						   len + sizeof(".TEMP"));
-			memcpy(stats_drift_file, value, (size_t)(len+1));
-			memcpy(stats_temp_file, value, (size_t)len);
-			memcpy(stats_temp_file + len, temp_ext, sizeof(temp_ext));
+						   len + sizeof(temp_ext));
+			memcpy(stats_drift_file, value, 1 + len);
+			memcpy(stats_temp_file, value, len);
+			memcpy(stats_temp_file + len, temp_ext, 
+			       sizeof(temp_ext));
 		}
-		
+
 		/*
 		 * Open drift file and read frequency. If the file is
 		 * missing or contains errors, tell the loop to reset.
 		 */
 		if (NULL == stats_drift_file) {
-			loop_config(LOOP_NOFREQ, 0.0);
-			prev_drift_comp = 0.0;
+			goto nofreq;
 		} else if ((fp = fopen(stats_drift_file, "r")) == NULL) {
-			if (errno != ENOENT)
+			if (errno != ENOENT) {
 				msyslog(LOG_WARNING,
-					"cannot read frequency file %s: %s",
-					stats_drift_file, strerror(errno));
+					"cannot read frequency file %s: %m",
+					stats_drift_file);
+			}
+			goto nofreq;
 		} else if (fscanf(fp, "%lf", &old_drift) != 1) {
 			msyslog(LOG_ERR,
 				"format error frequency file %s",
 				stats_drift_file);
-			fclose(fp);
+	nofreq:
+			prev_drift_comp = 0.0;
+			loop_config(LOOP_NOFREQ, prev_drift_comp);
 		} else {
 			loop_config(LOOP_FREQ, old_drift);
 			prev_drift_comp = drift_comp;
 			msyslog(LOG_INFO,
-				"initial drift restored to %f",
+				"initial drift restored to %.6f",
 				old_drift);
+		}
+		if (NULL != fp) {
 			fclose(fp);
 		}
 		break;
 
-	/*
-	 * Specify statistics directory.
-	 */
+		/*
+		 * Specify statistics directory.
+		 */
 	case STATS_STATSDIR:
-		if (!allow_config(STATS_STATSDIR, optflag))
+		if (!allow_config(STATS_STATSDIR, optflag)) {
 			break;
-
-		/* - 1 since value may be missing the DIR_SEP. */
-		if (strlen(value) >= sizeof(statsdir) - 1) {
+		}
+		/* - 2 since value may be missing the DIR_SEP. */
+		len = strlen(value);
+		if (len > sizeof(statsdir) - 2) {
 			msyslog(LOG_ERR,
-			    "statsdir too long (>%d, sigh)",
-			    (int)sizeof(statsdir) - 2);
+				"statsdir %s too long (>%u)", value,
+				(u_int)sizeof(statsdir) - 2);
+			break;
+		}
+		/* Add a DIR_SEP unless we already have one. */
+		if (0 == len || DIR_SEP == value[len - 1]) {
+			dirsep_or_nul = '\0';
 		} else {
-			int add_dir_sep;
-			size_t value_l;
-
-			/* Add a DIR_SEP unless we already have one. */
-			value_l = strlen(value);
-			if (0 == value_l)
-				add_dir_sep = FALSE;
-			else
-				add_dir_sep = (DIR_SEP !=
-				    value[value_l - 1]);
-
-			if (add_dir_sep)
-				snprintf(statsdir, sizeof(statsdir),
-				    "%s%c", value, DIR_SEP);
-			else
-				snprintf(statsdir, sizeof(statsdir),
-				    "%s", value);
-			filegen_statsdir();
+			dirsep_or_nul = DIR_SEP;
 		}
+		snprintf(statsdir, sizeof(statsdir), "%s%c",
+			 value, dirsep_or_nul);
+		filegen_statsdir();
 		break;
 
-	/*
-	 * Open pid file.
-	 */
+		/*
+		 * Write pid file.
+		 */
 	case STATS_PID_FILE:
-		if (!allow_config(STATS_PID_FILE, optflag))
+		if (!allow_config(STATS_PID_FILE, optflag)) {
 			break;
-		
+		}
 		if ((fp = fopen(value, "w")) == NULL) {
-			msyslog(LOG_ERR, "pid file %s: %m",
-			    value);
+			msyslog(LOG_ERR, "pid file %s: %m", value);
 			break;
 		}
-		fprintf(fp, "%d", (int)getpid());
+		fprintf(fp, "%ld", (long)getpid());
 		fclose(fp);
 		break;
 
 	/*
 	 * Read leapseconds file.
 	 *
-	 * Note: Currently a leap file without SHA1 signature is
-	 * accepted, but if there is a signature line, the signature
-	 * must be valid or the file is rejected.
+	 * By default a leap file without SHA1 signature is accepted,
+	 * but if there is a signature line, the signature must be
+	 * valid or the leapfile line in ntp.conf must have ignorehash.
 	 */
 	case STATS_LEAP_FILE:
-		if (!value || (len = strlen(value)) == 0)
+		if (NULL == value || 0 == (len = strlen(value))) {
 			break;
-
+		}
 		leapfile_name = erealloc(leapfile_name, len + 1);
 		memcpy(leapfile_name, value, len + 1);
 		chck_leaphash = optflag;
 
 		if (leapsec_load_file(
 			    leapfile_name, &leapfile_stat,
-			    TRUE, TRUE, chck_leaphash))
-		{
+			    TRUE, TRUE, chck_leaphash)) {
 			leap_signature_t lsig;
 
 			get_systime(&now);
 			time(&ttnow);
 			leapsec_getsig(&lsig);
 			mprintf_event(EVNT_TAI, NULL,
-				      "%d leap %s %s %s",
+				      "%d leap %s expire%s %s",
 				      lsig.taiof,
 				      fstostr(lsig.ttime),
 				      leapsec_expired(now.l_ui, NULL)
-					  ? "expired"
-					  : "expires",
+					  ? "d"
+					  : "s",
 				      fstostr(lsig.etime));
 
 			have_leapfile = TRUE;
@@ -579,31 +579,32 @@ stats_config(
 */
 void
 record_peer_stats(
-	sockaddr_u *addr,
-	int	status,
-	double	offset,		/* offset */
-	double	delay,		/* delay */
-	double	dispersion,	/* dispersion */
-	double	jitter		/* jitter */
+	sockaddr_u *	addr,
+	int		status,
+	double		offset,
+	double		delay,
+	double		dispersion,
+	double		jitter
 	)
 {
-	l_fp	now;
-	u_long	day;
+	l_fp		now;
+	u_long		day;
 
-	if (!stats_control)
+	if (!stats_control) {
 		return;
-
+	}
 	get_systime(&now);
 	filegen_setup(&peerstats, now.l_ui);
+	if (NULL == peerstats.fp) {
+		return;
+	}
 	day = now.l_ui / 86400 + MJD_1900;
 	now.l_ui %= 86400;
-	if (peerstats.fp != NULL) {
-		fprintf(peerstats.fp,
-		    "%lu %s %s %x %.9f %.9f %.9f %.9f\n", day,
-		    ulfptoa(&now, 3), stoa(addr), status, offset,
-		    delay, dispersion, jitter);
-		fflush(peerstats.fp);
-	}
+	fprintf(peerstats.fp,
+		"%lu %s %s %x %.9f %.9f %.9f %.9f\n", day,
+		ulfptoa(&now, 3), stoa(addr), status, offset,
+		delay, dispersion, jitter);
+	fflush(peerstats.fp);
 }
 
 
@@ -934,13 +935,14 @@ record_timing_stats(
  *
  * Note: This loads a new leapfile on the fly. Currently a leap file
  * without SHA1 signature is accepted, but if there is a signature line,
- * the signature must be valid or the file is rejected.
+ * the signature must be valid unless the ntp.conf leapfile line specified
+ * ignorehash.
  */
 void
 check_leap_file(
-	int           is_daily_check,
-	uint32_t      ntptime       ,
-	const time_t *systime
+	int		is_daily_check,
+	uint32_t	ntptime,
+	const time_t *	systime
 	)
 {
 	/* just do nothing if there is no leap file */
@@ -1097,3 +1099,20 @@ ntpd_time_stepped(void)
 	win_time_stepped();
 #endif
 }
+
+
+#ifdef DEBUG
+void
+append_flagstr(
+	char *		flagstr,
+	size_t		sz,
+	const char *	text
+)
+{
+	if ('\0' != flagstr[0]) {
+		strlcat(flagstr, ",", sz);
+	}
+	/* bail if we ran out of room */
+	INSIST(strlcat(flagstr, text, sz) < sz);
+}
+#endif	/* DEBUG */
diff --git a/contrib/ntp/ntpd/ntpd-opts.c b/contrib/ntp/ntpd/ntpd-opts.c
index 14774d684f2d..5d8b0bb33659 100644
--- a/contrib/ntp/ntpd/ntpd-opts.c
+++ b/contrib/ntp/ntpd/ntpd-opts.c
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (ntpd-opts.c)
  *
- *  It has been AutoGen-ed  June  6, 2023 at 04:36:50 AM by AutoGen 5.18.16
+ *  It has been AutoGen-ed  May 25, 2024 at 12:03:09 AM by AutoGen 5.18.16
  *  From the definitions    ntpd-opts.def
  *  and the template file   options
  *
@@ -18,7 +18,7 @@
  * The ntpd program is copyrighted and licensed
  * under the following terms:
  *
- *  Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.
+ *  Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.
  *  This is free software. It is licensed for use, modification and
  *  redistribution under the terms of the NTP License, copies of which
  *  can be seen at:
@@ -80,8 +80,8 @@ extern FILE * option_usage_fp;
  *  static const strings for ntpd options
  */
 static char const ntpd_opt_strs[3133] =
-/*     0 */ "ntpd 4.2.8p17\n"
-            "Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.\n"
+/*     0 */ "ntpd 4.2.8p18\n"
+            "Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.\n"
             "This is free software. It is licensed for use, modification and\n"
             "redistribution under the terms of the NTP License, copies of which\n"
             "can be seen at:\n"
@@ -210,12 +210,12 @@ static char const ntpd_opt_strs[3133] =
 /*  2901 */ "output version information and exit\0"
 /*  2937 */ "version\0"
 /*  2945 */ "NTPD\0"
-/*  2950 */ "ntpd - NTP daemon program - Ver. 4.2.8p17\n"
+/*  2950 */ "ntpd - NTP daemon program - Ver. 4.2.8p18\n"
             "Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... \\\n"
             "\t\t[ <server1> ... <serverN> ]\n\0"
 /*  3082 */ "https://bugs.ntp.org, bugs@ntp.org\0"
 /*  3117 */ "\n\0"
-/*  3119 */ "ntpd 4.2.8p17";
+/*  3119 */ "ntpd 4.2.8p18";
 
 /**
  *  ipv4 option description with
@@ -1534,8 +1534,8 @@ static void bogus_function(void) {
      translate option names.
    */
   /* referenced via ntpdOptions.pzCopyright */
-  puts(_("ntpd 4.2.8p17\n\
-Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.\n\
+  puts(_("ntpd 4.2.8p18\n\
+Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.\n\
 This is free software. It is licensed for use, modification and\n\
 redistribution under the terms of the NTP License, copies of which\n\
 can be seen at:\n"));
@@ -1675,7 +1675,7 @@ implied warranty.\n"));
   puts(_("output version information and exit"));
 
   /* referenced via ntpdOptions.pzUsageTitle */
-  puts(_("ntpd - NTP daemon program - Ver. 4.2.8p17\n\
+  puts(_("ntpd - NTP daemon program - Ver. 4.2.8p18\n\
 Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... \\\n\
 \t\t[ <server1> ... <serverN> ]\n"));
 
@@ -1683,7 +1683,7 @@ Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... \\\n\
   puts(_("\n"));
 
   /* referenced via ntpdOptions.pzFullVersion */
-  puts(_("ntpd 4.2.8p17"));
+  puts(_("ntpd 4.2.8p18"));
 
   /* referenced via ntpdOptions.pzFullUsage */
   puts(_("<<<NOT-FOUND>>>"));
